<template>
  <v-snackbar
    min-width="344"
    max-width="496"
    :color="color"
    v-model="snackbar"
    :content-class="customClass"
    :vertical="vertical"
    :multi-line="multiLine"
    @update:model-value="update"
  >
    <div class="w-full">
      <svn-pro-text
        bodyMedium
        color="onPrimary"
      >
        {{ supportingText }}
      </svn-pro-text>
    </div>

    <template v-if="action || close" #actions>
      <svn-pro-button
        v-if="action"
        variant="text"
        :text="actionText"
        @click="onActionClicked"
      />

      <svn-pro-icon-button
        v-if="close"
        color="onPrimary"
        icon="mdi-close"
        variant="text"
        @click="onCloseClicked"
      />
    </template>
  </v-snackbar>
</template>

<script setup>
import { ref, watch, onMounted } from "vue";
import SvnProText from "../styles/SvnProText.vue";
import SvnProButton from "../button/SvnProButton.vue";
import SvnProIconButton from "../button/SvnProIconButton.vue";

const emit = defineEmits(['update:modelValue', 'action-clicked', 'close-clicked']);

const snackbar = ref(null);

onMounted(() => {
  snackbar.value = props?.modelValue
})

const props = defineProps({
  modelValue: {
    type: Boolean,
    default: false,
  },
  action: {
    type: Boolean,
    default: false,
  },
  vertical: {
    type: Boolean,
    default: false,
  },
  close: {
    type: Boolean,
    default: false,
  },
  customClass: {
    type: String,
    default: "",
  },
  actionText: {
    type: String,
    default: "Action",
  },
  multiLine: {
    type: Boolean,
    default: false,
  },
  supportingText: {
    type: String,
    default: "Snackbar supporting text",
  },
  color: {
    type: String,
    default: "onSurface",
  }
})

const update = () => {
  emit('update:modelValue', snackbar?.value)
}

const onActionClicked = () => {
  snackbar.value = false
  emit('action-clicked')
}

const onCloseClicked = () => {
  snackbar.value = false
  emit('close-clicked')
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    snackbar.value = newValue?.modelValue;
  }
})

defineExpose({
  snackbar
})
</script>